<?php

namespace App\Filament\Resources;

use App\Filament\Resources\PendatangResource\Pages;
use App\Filament\Resources\PendatangResource\RelationManagers;
use App\Models\AnggotaKartuKeluarga;
use App\Models\Dusun;
use App\Models\Pendatang;
use Filament\Forms;
use Filament\Forms\Components\DatePicker;
use Filament\Forms\Form;
use Filament\Resources\Resource;
use Filament\Tables;
use Filament\Tables\Filters\Filter;
use Filament\Tables\Filters\SelectFilter;
use Filament\Tables\Table;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Log;
use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\SoftDeletingScope;
use Illuminate\Support\Collection;
use Illuminate\Support\Facades\Auth;

class PendatangResource extends Resource
{
    protected static ?string $model = Pendatang::class;

    protected static ?string $navigationIcon = 'heroicon-o-arrow-down-on-square';
    protected static ?string $navigationGroup = 'Sirkulasi Penduduk';
    protected static ?string $navigationLabel = 'Data Pendatang';
    protected static ?int $navigationSort = 3;

    public static function form(Form $form): Form
    {
        return $form
            ->schema([
                Forms\Components\TextInput::make('nik')
                    ->integer()
                    ->required()
                    ->minLength(16)
                    ->maxLength(16)
                    ->placeholder('Masukan nomor NIK'),
                Forms\Components\TextInput::make('nama')
                    ->required()
                    ->placeholder('Masukan nama')
                    ->maxLength(255),
                Forms\Components\TextInput::make('tempat_lahir')
                    ->placeholder('Masukan tempat lahir')
                    ->required()
                    ->maxLength(255),
                Forms\Components\DatePicker::make('tanggal_lahir')
                    ->required(),
                Forms\Components\Select::make('jenis_kelamin')
                    ->options([
                        'laki' => 'Laki-laki',
                        'perempuan' => 'Perempuan',
                    ])
                    ->required(),
                // Forms\Components\TextInput::make('alamat_asal')
                //     ->placeholder('Masukan alamat asal')
                //     ->maxLength(255)
                //     ->default(null),
                Forms\Components\TextInput::make('alamat_tujuan')
                    ->placeholder('Masukan alamat pindah')
                    ->maxLength(255)
                    ->default(null),
                Forms\Components\Select::make('dusun_id_tujuan')
                    ->label("Dusun Tujuan")
                    ->options(Dusun::where('status','aktif')->where('tipe', 'utama')->where('id', Auth::user()->dusun_id)->pluck('nama', 'id'))
                    ->default('3')
                    ->required(),
                Forms\Components\Select::make('sub_dusun_id')
                    ->options(Dusun::where('status','aktif')->where('tipe', 'sub_dusun')->pluck('nama', 'id'))
                    ->label("Sub Dusun"),
                Forms\Components\Select::make('agama')
                    ->options([
                        'Islam' => 'Islam',
                        'Kristen Protestan' => 'Kristen Protestan',
                        'Katolik' => 'Katolik',
                        'Hindu' => 'Hindu',
                        'Buddha' => 'Buddha',
                        'Konghucu' => 'Konghucu',
                    ])
                    ->nullable(),
                // Forms\Components\Select::make('perkawinan')
                //     ->options([
                //         'sudah' => 'Sudah Kawin',
                //         'belum' => 'Belum Kawin',
                //         'cerai_mati' => 'Cerai Mati',
                //         'cerai_hidup' => 'Cerai Hidup',
                //     ])
                //     ->required(),
                // Forms\Components\TextInput::make('pekerjaan')
                //     ->required()
                //     ->placeholder('Masukan Nama Pekerjaan')
                //     ->maxLength(255),
                Forms\Components\DatePicker::make('tanggal_datang')
                    ->required(),
                Forms\Components\TextInput::make('alasan_datang')
                    ->placeholder('Masukan alasan datang ke dusun ini')
                    ->maxLength(255),
                Forms\Components\Select::make('tujuan_datang')
                    ->options([
                        'tamu' => 'Tamu',
                        'tetap' => 'Menetap (tinggal disini)',
                    ])
                    ->required(),
            ]);
    }

    public static function table(Table $table): Table
    {
        return $table
            ->columns([
                Tables\Columns\TextColumn::make('penduduk.nik')
                    ->label("NIK")
                    ->searchable(),
                Tables\Columns\TextColumn::make('penduduk.nama')
                    ->label("Nama")
                    ->searchable(),
                Tables\Columns\TextColumn::make('penduduk.jenis_kelamin')
                    ->label("Jenis Kelamin"),
                Tables\Columns\TextColumn::make('penduduk.alamat')
                    ->label("Alamat Tujuan")
                    ->default('-')
                    ->searchable(),
                Tables\Columns\TextColumn::make('tujuan_datang')
                    ->default('-')
                    ->sortable(),
                Tables\Columns\TextColumn::make('alasan_datang')
                    ->default('-')
                    ->sortable(),
                Tables\Columns\TextColumn::make('tanggal_datang')
                    ->date()
                    ->sortable(),
                Tables\Columns\TextColumn::make('created_at')
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
                Tables\Columns\TextColumn::make('updated_at')
                    ->dateTime()
                    ->sortable()
                    ->toggleable(isToggledHiddenByDefault: true),
            ])
            ->filters([
                //
                SelectFilter::make('dusun_id_tujuan')
                    ->label('Dusun Tujuan')
                    ->relationship('penduduk.dusun', 'nama') // Filter berdasarkan dusun dari relasi penduduk
                    ->preload(), // Untuk memuat semua opsi dusun
                Filter::make('tanggal_datang')
                    ->form([
                        DatePicker::make('tanggal_datang_dari')
                            ->placeholder('Tanggal Dari'),
                        DatePicker::make('tanggal_datang_sampai')
                            ->placeholder('Tanggal Sampai'),
                    ])
                    ->query(function (Builder $query, array $data): Builder {
                        return $query
                            ->when(
                                $data['tanggal_datang_dari'],
                                fn (Builder $query, $date): Builder => $query->whereDate('tanggal_datang', '>=', $date),
                            )
                            ->when(
                                $data['tanggal_datang_sampai'],
                                fn (Builder $query, $date): Builder => $query->whereDate('tanggal_datang', '<=', $date),
                            );
                    })
            ])
            ->actions([
                // Tables\Actions\EditAction::make(),
                Tables\Actions\Action::make('edit_penduduk')
                    ->label('Edit Data Pengunjung')
                    ->color('warning')
                    ->icon('heroicon-o-pencil')
                    ->url(fn (Pendatang $record): string => 
                        // atau akses langsung penduduk_id
                        $record->penduduk 
                            ? \App\Filament\Resources\PendudukResource::getUrl('edit', ['record' => $record->penduduk->id])
                            : '#' // Fallback jika tidak ada penduduk terkait
                    )
                    ->visible(fn (Pendatang $record): bool => $record->tujuan_datang === 'tamu' && Auth::user()->role !== 'kepala_desa'), 
                Tables\Actions\Action::make('deleteCustom')
                    ->label('Hapus')
                    ->color('danger')
                    ->icon('heroicon-o-trash')
                    ->requiresConfirmation() 
                    ->visible(fn (): bool => Auth::user()->role === 'admin_desa')
                    ->action(function (Pendatang $record) { 
                        DB::transaction(function () use ($record) {

                            $penduduk = $record->penduduk;

                            if ($penduduk) {
                                Log::info('Penduduk terkait ditemukan: ' . $penduduk->id . ' - ' . $penduduk->nama);
                                $penduduk->update(['is_ignore' => false]);
                                // Hapus entri di AnggotaKartuKeluarga yang terkait
                                $deletedAnggota = AnggotaKartuKeluarga::where('penduduk_id', $penduduk->id)
                                                                    ->delete();
                                Log::info('Jumlah anggota keluarga dihapus: ' . $deletedAnggota);
                                
                                // Hanya hapus penduduk jika tidak ada kaitan lain
                                $penduduk->delete();
                                Log::info('Menghapus penduduk: ' . $penduduk->nama . ' karena tidak ada relasi lain.');
                            } else {
                                Log::info('Tidak ada penduduk terkait ditemukan untuk Kelahiran ID: ' . $record->id);
                            }

                            // Hapus record Kelahiran itu sendiri
                            $record->delete();
                            Log::info('Record Kelahiran ID: ' . $record->id . ' berhasil dihapus.');
                        });
                    }),
            ])
            ->bulkActions([
                Tables\Actions\BulkActionGroup::make([
                    Tables\Actions\DeleteBulkAction::make()
                    ->visible(fn (): bool => Auth::user()->role === 'admin_desa')
                    ->action(function (Collection $records) {
                        DB::transaction(function () use ($records) {

                            foreach ($records as $record) {
                                $penduduk = $record->penduduk;

                                if ($penduduk) {
                                    Log::info('Penduduk terkait ditemukan: ' . $penduduk->id . ' - ' . $penduduk->nama);
                                    $penduduk->update(['is_ignore' => false]);
                                    // Hapus entri di AnggotaKartuKeluarga yang terkait
                                    $deletedAnggota = AnggotaKartuKeluarga::where('penduduk_id', $penduduk->id)
                                                                        ->delete();
                                    Log::info('Jumlah anggota keluarga dihapus: ' . $deletedAnggota);
                                    
                                    // Hanya hapus penduduk jika tidak ada kaitan lain
                                    $penduduk->delete();
                                    Log::info('Menghapus penduduk: ' . $penduduk->nama . ' karena tidak ada relasi lain.');
                                } else {
                                    Log::info('Tidak ada penduduk terkait ditemukan untuk Kelahiran ID: ' . $record->id);
                                }

                                // Hapus record Kelahiran itu sendiri
                                $record->delete();
                                Log::info('Record Kelahiran ID: ' . $record->id . ' berhasil dihapus.');
                            }
                        });
                    }),
                ]),
            ]);
    }

    
    public static function getEloquentQuery(): Builder
    {       
        $user = Auth::user();

        $query = parent::getEloquentQuery()
            ->with('penduduk');

        if ($user->role === 'admin_dusun') {
            $query->whereHas('penduduk', function ($q) use ($user) {
                $q->where('dusun_id', $user->dusun_id);
            });
        }

        return $query;
    }
    
    public static function getRelations(): array
    {
        return [
            //
        ];
    }

    public static function getPages(): array
    {
        return [
            'index' => Pages\ListPendatangs::route('/'),
            'create' => Pages\CreatePendatang::route('/create'),
            'edit' => Pages\EditPendatang::route('/{record}/edit'),
        ];
    }
    
 /*   public static function canAccess(): bool
    {
        return Auth::user()->role !== 'warga';
    } */
}
